/*
 ============================================================================
 Name        : soundEguitar.c
 Author      : 
 Version     :
 Copyright   : Your copyright notice
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <poll.h>
#include <alsa/asoundlib.h>

#include <math.h>



int CaptureLength = 0;
unsigned int j = 0;
unsigned int k = 0;
int FrameStart = 0;
int err = 0;
snd_pcm_t *capture_handle;
snd_pcm_hw_params_t *hw_params;
float buf[4800]={0};


snd_pcm_t *playback_handle;
snd_pcm_hw_params_t *hw_params_out;
float buf_out[4800]={0};


#define D_SAMPLERATE 48000
#define D_FRAMECOUNT (512)
#define D_PERIODS 2 
#define D_SLEEP 1000


#include "parameter.h"

char* pcm_name = 0;
unsigned int samplerate = D_SAMPLERATE;


snd_pcm_sw_params_t *sw_params;
snd_pcm_sframes_t frames_to_deliver;
int nfds;
int err;
struct pollfd *pfds;

float x0 =0.0;

#define D_ALGO_VALUES
#include "algorithm.h"
#undef D_ALGO_VALUES

float max_anreg =1.0;


playback_callback (snd_pcm_sframes_t nframes)
{
	int err;

//	printf ("playback callback called with %u frames\n", nframes);

	while(CaptureLength < (nframes))
	{
		CaptureLength += snd_pcm_readi (capture_handle, &buf[CaptureLength*2], nframes);
	}

	/* ... fill buf with data ... */
	for (j = 0; j < ((nframes)); ++j)
	{
		//buf_out[j]= buf[j];
		 for (k=0;k < D_INTERPOL ; k++)
		 {
			#define D_ALGO
			#include "algorithm.h"
			#undef D_ALGO
		 }
		 buf_out[j*2]  =x0;
		 buf_out[j*2+1]=x0;
	}


	if ((err = snd_pcm_writei (playback_handle, buf_out, nframes)) < 0) {
		if ((err = snd_pcm_prepare (playback_handle)) < 0) {
			fprintf (stderr, "cannot prepare audio interface for use (%s)\n",
				 snd_strerror (err));
			exit (1);
		}
		err = nframes;
	}


	CaptureLength= 0;
	FrameStart=0;




	return err;
}



int main(void) {
	puts("!!!Hello World!!!"); /* prints !!!Hello World!!! */





	/* Init pcm_name. Of course, later you */
	    /* will make this configurable ;-)     */
	pcm_name = strdup("plughw:0,0");



	if ((err = snd_pcm_open (&capture_handle, pcm_name, SND_PCM_STREAM_CAPTURE, 0)) < 0) {
		fprintf (stderr, "cannot open audio device %s (%s)\n",
			 pcm_name,
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_malloc (&hw_params)) < 0) {
		fprintf (stderr, "cannot allocate hardware parameter structure (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_any (capture_handle, hw_params)) < 0) {
		fprintf (stderr, "cannot initialize hardware parameter structure (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_access (capture_handle, hw_params, SND_PCM_ACCESS_RW_INTERLEAVED)) < 0) {
		fprintf (stderr, "cannot set access type (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_format (capture_handle, hw_params, SND_PCM_FORMAT_FLOAT_LE)) < 0) {
		fprintf (stderr, "cannot set sample format (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_rate_near (capture_handle, hw_params, &samplerate, 0)) < 0) {
		fprintf (stderr, "cannot set sample rate (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_channels (capture_handle, hw_params, 2)) < 0) {
		fprintf (stderr, "cannot set channel count (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params (capture_handle, hw_params)) < 0) {
		fprintf (stderr, "cannot set parameters (%s)\n",
			 snd_strerror (err));
		exit (1);
	}




	if ((err = snd_pcm_open (&playback_handle, pcm_name, SND_PCM_STREAM_PLAYBACK, 0)) < 0) {
		fprintf (stderr, "cannot open audio device %s (%s)\n",
				pcm_name,
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_malloc (&hw_params_out)) < 0) {
		fprintf (stderr, "cannot allocate hardware parameter structure (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_any (playback_handle, hw_params_out)) < 0) {
		fprintf (stderr, "cannot initialize hardware parameter structure (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_access (playback_handle, hw_params_out, SND_PCM_ACCESS_RW_INTERLEAVED)) < 0) {
		fprintf (stderr, "cannot set access type (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_format (playback_handle, hw_params_out, SND_PCM_FORMAT_FLOAT_LE)) < 0) {
		fprintf (stderr, "cannot set sample format (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_rate_near (playback_handle, hw_params_out, &samplerate, 0)) < 0) {
		fprintf (stderr, "cannot set sample rate (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_hw_params_set_channels (playback_handle, hw_params_out, 2)) < 0) {
		fprintf (stderr, "cannot set channel count (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
    /* Set number of periods. Periods used to be called fragments. */
    if (snd_pcm_hw_params_set_periods(playback_handle, hw_params_out, D_PERIODS, 0) < 0) {
      fprintf(stderr, "Error setting periods.\n");
      return(-1);
    }
    /* Set buffer size (in frames). The resulting latency is given by */
    /* latency = periodsize * periods / (rate * bytes_per_frame)     */
    if (snd_pcm_hw_params_set_buffer_size(playback_handle, hw_params_out, D_FRAMECOUNT) < 0) {
      fprintf(stderr, "Error setting buffersize.\n");
      return(-1);
    }
	if ((err = snd_pcm_hw_params (playback_handle, hw_params_out)) < 0) {
		fprintf (stderr, "cannot set parameters (%s)\n",
		snd_strerror (err));
		exit (1);
	}





	/* tell ALSA to wake us up whenever 4096 or more frames
	   of playback data can be delivered. Also, tell
	   ALSA that we'll start the device ourselves.
	*/

	if ((err = snd_pcm_sw_params_malloc (&sw_params)) < 0) {
		fprintf (stderr, "cannot allocate software parameters structure (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_sw_params_current (playback_handle, sw_params)) < 0) {
		fprintf (stderr, "cannot initialize software parameters structure (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_sw_params_set_avail_min (playback_handle, sw_params, 128)) < 0) {
		fprintf (stderr, "cannot set minimum available count (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_sw_params_set_start_threshold (playback_handle, sw_params, 0U)) < 0) {
		fprintf (stderr, "cannot set start mode (%s)\n",
			 snd_strerror (err));
		exit (1);
	}
	if ((err = snd_pcm_sw_params (playback_handle, sw_params)) < 0) {
		fprintf (stderr, "cannot set software parameters (%s)\n",
			 snd_strerror (err));
		exit (1);
	}

	/* the interface will interrupt the kernel every 4096 frames, and ALSA
	   will wake up this program very soon after that.
	*/








	if ((err = snd_pcm_prepare (capture_handle)) < 0) {
		fprintf (stderr, "cannot prepare audio interface for use (%s)\n",
			 snd_strerror (err));
		exit (1);
	}

	if ((err = snd_pcm_prepare (playback_handle)) < 0) {
		fprintf (stderr, "cannot prepare audio interface for use (%s)\n",
			 snd_strerror (err));
		exit (1);
	}

//	for (j=0; j < 4;j++)
//	{
//		snd_pcm_writei (playback_handle, &buf_out[0], D_FRAMECOUNT);
//	}

	while(1)
	{
//		static float runtime = 0;

//		fprintf(stderr, "YES! p%d c%d\n",CaptureLength,FrameStart);
//		fprintf(stderr,"%d",i);
//		i++;






		/* find out how much space is available for playback data */

		if ((frames_to_deliver = snd_pcm_avail_update (playback_handle)) < 0) {
//			if (frames_to_deliver == -EPIPE) {
//				fprintf (stderr, "an xrun occured\n");
//				break;
//			} else {
//				fprintf (stderr, "unknown ALSA avail update return value (%d)\n",
//					 frames_to_deliver);
//				break;
//			}
			frames_to_deliver = 64;
			if ((err = snd_pcm_prepare (playback_handle)) < 0) {
				fprintf (stderr, "cannot prepare audio interface for use (%s)\n",
					 snd_strerror (err));
				exit (1);
			}
		}

		frames_to_deliver = frames_to_deliver > 4096 ? 4096 : frames_to_deliver;

		/* deliver the data */
//		if ((err = snd_pcm_wait (playback_handle, 4/*10*/)) < 0) {
//				fprintf (stderr, "poll failed (%s)\n", strerror (err));
//				break;
//		}
		if (playback_callback (frames_to_deliver) != frames_to_deliver) {
				fprintf (stderr, "playback callback failed\n");
			break;
		}
		//if (FrameStart <40)
		{
			usleep(D_SLEEP);
		}


	}

	snd_pcm_close (capture_handle);
	snd_pcm_close (playback_handle);

	snd_pcm_hw_params_free (hw_params);
	snd_pcm_hw_params_free (hw_params_out);

	return EXIT_SUCCESS;
}
